; 23-03-2011  Stephan Herkt
; Wochentagsanzeige fuer die Funkuhr mit Datum von Arne Rossius
; - angepasste Version von Arnes Prg erforderlich ( dcf-wt91 ) -
; ==============================================================
; ATMEGA8
; Fuses : 
; BOOTSZ : Boot Flash size=1024 words Boot address=$0C00
; BODLEVEL : Brown-out detection at VCC=2.7V
; SUT_CKSEL : Int. RC Osc. 8MHz; Start-up time 6 CK + 64ms
; High : 0xD9
; LOW : 0xE4

;-----------------------------------------------------Definitionen

.nolist
.include "D:\Utils\Atmel\AVR Tools\AvrAssembler2\Appnotes\m8def.inc"
.list

.def 	sreg_backup = R0
.def	temp	= R16
.def	Datum	= R17
.def	anz1	= R18
.def	anz2	= R19
.def	anz3	= R20
.def	w1		= R22
.def	w2		= R23
.def	temp2	= R25


;--------------------------------------------------Initialisierung

.org 0x000 					  ; Define start of Code segment 

	   rjmp Main
.org INT0addr                 ; External Interrupt0 Vector Address
       reti                   
.org INT1addr				  ; External Interrupt1 Vector Address
	   rjmp int1_handler
.org OC2addr                  ; Output Compare2 Interrupt Vector Address
       reti                   
.org OVF2addr                 ; Overflow2 Interrupt Vector Address
       reti                   
.org ICP1addr                 ; Input Capture1 Interrupt Vector Address
       reti                   
.org OC1Aaddr                 ; Output Compare1A Interrupt Vector Address
       reti                   
.org OC1Baddr                 ; Output Compare1B Interrupt Vector Address
       reti                   
.org OVF1addr                 ; Overflow1 Interrupt Vector Address
       reti                   
.org OVF0addr                 ; Overflow0 Interrupt Vector Address
       reti                   
.org SPIaddr                  ; SPI Interrupt Vector Address
       reti                   
.org URXCaddr                 ; USART Receive Complete Interrupt Vector Address
       reti                   
.org UDREaddr                 ; USART Data Register Empty Interrupt Vector Address
       reti                   
.org UTXCaddr                 ; USART Transmit Complete Interrupt Vector Address
       reti                   
.org ADCCaddr                 ; ADC Interrupt Vector Address
       reti                   
.org ERDYaddr                 ; EEPROM Interrupt Vector Address
       reti                   
.org ACIaddr                  ; Analog Comparator Interrupt Vector Address
       reti                   
.org TWIaddr                  ; Irq. vector address for Two-Wire Interface
       reti                   
; .org SPMaddr                  ; SPM complete Interrupt Vector Address
;       reti                   
.org SPMRaddr                 ; SPM complete Interrupt Vector Address
       reti                   
 
.org INT_VECTORS_SIZE



Main :

        ldi temp, LOW(RAMEND)             ; LOW-Byte der obersten RAM-Adresse
        out SPL, temp
        ldi temp, HIGH(RAMEND)            ; HIGH-Byte der obersten RAM-Adresse
        out SPH, temp
		ldi temp, 0b00001000			  ; INT1 - fallende Flanke
		out MCUCR, temp
		ldi temp, 0b10000000			  ; Ext. INT1 eingeschaltet
		out GICR, temp


	;I/O ports
	ldi	temp, 0xFF
	out	DDRB, temp
	out	PORTB, temp
	ldi	temp, 0b01111111 ; Reset = kein Ausgang
	out	DDRC, temp
	out	PORTC, temp
	ldi	temp, 0b11110000 ; PD0-PD3 = Eingang; PD4-PD7 = Ausgang
	out	DDRD, temp
	out	PORTD, temp


Anf :	 	ldi	Datum, 0x07
			ldi	temp2, 0x07
			ldi R24, 0x00
			ldi R21, 0x00
		
			sei					 ; Interrupts generell einschalten


check:		
			mov Datum, temp2

			cpi 	Datum, 0x06
			breq Date0
			cpi 	Datum, 0x05
			breq Date1
			cpi 	Datum, 0x04
			breq Date2
			cpi 	Datum, 0x03
			breq Date3
			cpi 	Datum, 0x02
			breq Date4
			cpi 	Datum, 0x01
			breq Date5
			cpi 	Datum, 0x00
			breq Date6
			rcall NODATA
			
			rjmp check

Date0 :		rcall Montag
			rjmp check

Date1 : 	rcall Dienstag
			rjmp check
		
Date2 : 	rcall Mittwoch
			rjmp check

Date3 : 	rcall Donnerstag
			rjmp check

Date4 : 	rcall Freitag
			rjmp check

Date5 : 	rcall Samstag
			rjmp check

Date6 : 	rcall Sonntag
			rjmp check



Montag :

	ldi	anz1,	0b11110000 ;keine Stelle 1
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11110001 ;keine Stelle 2
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10010010 ; M, Stelle 3
	ldi	anz2,	0b11101100
	ldi	anz3,	0b11101111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b00000011 ;O, Stelle 4
	ldi	anz2,	0b00111100
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10010100 ;N, Stelle 5
	ldi	anz2,	0b00101100
	ldi	anz3,	0b11011111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT
	
	ldi	anz1,	0b11100101 ; T, Stelle 6
	ldi	anz2,	0b00011111
	ldi	anz3,	0b10111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10000110 ; A, Stelle 7
	ldi	anz2,	0b00110000
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b00100111 ; G, Stelle 8
	ldi	anz2,	0b00110100
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11111000 ; keine Stelle 9
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11111001 ; keine Stelle 10
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

 	ret

Dienstag :

	ldi	anz1,	0b11110000 ;keine Stelle 1
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b00000001 ;D, Stelle 2
	ldi	anz2,	0b00011111
	ldi	anz3,	0b10110000
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11110010 ;I, Stelle 3
	ldi	anz2,	0b11011111
	ldi	anz3,	0b10111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b01100011 ;E, Stelle 4
	ldi	anz2,	0b00111000
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10010100 ;N, Stelle 5
	ldi	anz2,	0b00101100
	ldi	anz3,	0b11011111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT
	
	ldi	anz1,	0b00100101 ; S, Stelle 6
	ldi	anz2,	0b00110001
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11100110 ; T, Stelle 7
	ldi	anz2,	0b00011111
	ldi	anz3,	0b10111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10000111 ; A, Stelle 8
	ldi	anz2,	0b00110000
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b00101000 ; G, Stelle 9
	ldi	anz2,	0b00110100
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11111001 ; keine Stelle 10
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ret


 Mittwoch :

	ldi	anz1,	0b11110000 ;keine Stelle 1
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10010001 ;M, Stelle 2
	ldi	anz2,	0b11101100
	ldi	anz3,	0b11101111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11110010 ;I, Stelle 3
	ldi	anz2,	0b11011111
	ldi	anz3,	0b10111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11100011 ;T, Stelle 4
	ldi	anz2,	0b00011111
	ldi	anz3,	0b10111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11100100 ;T, Stelle 5
	ldi	anz2,	0b00011111
	ldi	anz3,	0b10111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10010101 ;W, Stelle 6
	ldi	anz2,	0b11111100
	ldi	anz3,	0b01011111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b00000110 ;O, Stelle 7
	ldi	anz2,	0b00111100
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b01100111 ; C, Stelle 8
	ldi	anz2,	0b11111100
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10011000 ; H, Stelle 9
	ldi	anz2,	0b11110000
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11111001 ; keine Stelle 10
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ret


Donnerstag :

	ldi	anz1,	0b00000000 ;D, Stelle 1
	ldi	anz2,	0b00011111
	ldi	anz3,	0b10110000
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b00000001 ;O, Stelle 2
	ldi	anz2,	0b00111100
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10010010 ;N, Stelle 3
	ldi	anz2,	0b00101100
	ldi	anz3,	0b11011111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT
	
	ldi	anz1,	0b10010011 ;N, Stelle 4
	ldi	anz2,	0b00101100
	ldi	anz3,	0b11011111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b01100100 ; E, Stelle 5
	ldi	anz2,	0b00111000
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11000101 ; R, Stelle 6
	ldi	anz2,	0b00110000
	ldi	anz3,	0b11011111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b00100110 ; S, Stelle 7
	ldi	anz2,	0b00110001
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11100111 ; T, Stelle 8
	ldi	anz2,	0b00011111
	ldi	anz3,	0b10111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10001000 ; A, Stelle 9
	ldi	anz2,	0b00110000
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b00101001 ; G, Stelle 10
	ldi	anz2,	0b00110100
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ret

Freitag :
	
	ldi	anz1,	0b11110000 ;keine Stelle 1
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11100001 ;F, Stelle 2
	ldi	anz2,	0b00111000
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11000010 ;R, Stelle 3
	ldi	anz2,	0b00110000
	ldi	anz3,	0b11011111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT
	
	ldi	anz1,	0b01100011 ;E, Stelle 4
	ldi	anz2,	0b00111000
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11110100 ;I, Stelle 5
	ldi	anz2,	0b11011111
	ldi	anz3,	0b10111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11100101 ; T, Stelle 6
	ldi	anz2,	0b00011111
	ldi	anz3,	0b10111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10000110 ; A, Stelle 7
	ldi	anz2,	0b00110000
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b00100111 ; G, Stelle 8
	ldi	anz2,	0b00110100
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11111000 ; keine Stelle 9
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11111001 ; keine Stelle 10
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ret


Samstag :
	
	ldi	anz1,	0b11110000 ;keine Stelle 1
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b00100001 ; S, Stelle 2
	ldi	anz2,	0b00110001
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10000010 ; A, Stelle 3
	ldi	anz2,	0b00110000
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10010011 ; M, Stelle 4
	ldi	anz2,	0b11101100
	ldi	anz3,	0b11101111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b00100100 ; S, Stelle 2
	ldi	anz2,	0b00110001
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11100101 ; T, Stelle 6
	ldi	anz2,	0b00011111
	ldi	anz3,	0b10111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10000110 ; A, Stelle 7
	ldi	anz2,	0b00110000
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b00100111 ; G, Stelle 8
	ldi	anz2,	0b00110100
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11111000 ; keine Stelle 9
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11111001 ; keine Stelle 10
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ret

Sonntag :

	ldi	anz1,	0b11110000 ;keine Stelle 1
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b00100001 ; S, Stelle 2
	ldi	anz2,	0b00110001
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b00000010 ;O, Stelle 3
	ldi	anz2,	0b00111100
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10010011 ;N, Stelle 4
	ldi	anz2,	0b00101100
	ldi	anz3,	0b11011111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT
	
	ldi	anz1,	0b10010100 ;N, Stelle 5
	ldi	anz2,	0b00101100
	ldi	anz3,	0b11011111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11100101 ; T, Stelle 6
	ldi	anz2,	0b00011111
	ldi	anz3,	0b10111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b10000110 ; A, Stelle 7
	ldi	anz2,	0b00110000
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b00100111 ; G, Stelle 8
	ldi	anz2,	0b00110100
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11111000 ; keine Stelle 9
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

	ldi	anz1,	0b11111001 ; keine Stelle 10
	ldi	anz2,	0b11111111
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT

 	ret

NODATA :

	ldi	anz1,	0b11110100; --
	ldi	anz2,	0b11110011
	ldi	anz3,	0b11111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT1

	ldi	anz1,	0b11110100; \
	ldi	anz2,	0b11101111; \
	ldi	anz3,	0b11011111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT1

	ldi	anz1,	0b11110100; |
	ldi	anz2,	0b11011111; |
	ldi	anz3,	0b10111111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT1

	ldi	anz1,	0b11110100; /
	ldi	anz2,	0b11111111;/
	ldi	anz3,	0b01101111
	out	PORTB, anz1
	out	PORTC, anz2
	out	PORTD, anz3
	rcall WAIT1

	ret

WAIT :
WGLOOP0:  ldi  w1, $0C
WGLOOP1:  ldi  w2, $34
WGLOOP2:  dec  w2
          brne WGLOOP2
          dec  w1
          brne WGLOOP1
          brne WGLOOP0
		  ret

WAIT1 :
WGLOOP3:  ldi  w1, $FF
WGLOOP4:  ldi  w2, $FF
WGLOOP5:  dec  w2
          brne WGLOOP5
          dec  w1
          brne WGLOOP4
          brne WGLOOP3
		  ret


int1_handler :
			push Datum
			in sreg_backup, SREG

			ldi R21, 0x20 ; Einleseverzgerung
Loop :
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			dec R21
			brne Loop
			nop
			in R24, PIND
			andi R24, 0b00000111
			mov temp2, R24
			out SREG, sreg_backup
			pop Datum
			reti


